<?
/**
 * TorrentTrader v1.0.2 LITE 
 *  - Coded by Sqrtboy (sqrtboy@phpsoft.org)
 *  - Released under the GPL licence
 *  - Support/Hacks/Discussion @ http://www.torrenttrader.com
 **/

  $info_hash = (string)$_GET['info_hash'];

  if (strlen($info_hash) != 40 || !file_exists('torrents/'.$info_hash.'.torrent'))
  {
  // invalid info_hash format
  header("Location: index.php");
  exit();
  }
  else
  {
        // we check if the info_hash is in database
        $source = fopen('data/torrents.dat','r+');
        flock($source, LOCK_EX) ;
        $found = 0 ;
        while ($info = fscanf ($source, "%s %s %s %d %d %s %s %d %d %d %d\n")) {
        list ($prev_info_hash, $filename, $name,$size,$numfiles,$descr,$category,$seeders,$leechers,$completed,$hits) = $info;
         if ($info_hash ==  $prev_info_hash)
          {
            // found
            $fname = $filename;
            $found += 1;
            $content .= sprintf("%s %s %s %d %d %s %s %d %d %d %d\n",$prev_info_hash, $filename, $name,$size,$numfiles,$descr,$category,$seeders,$leechers,$completed,$hits+1);
         }
         else
         $content .= sprintf("%s %s %s %d %d %s %s %d %d %d %d\n",$prev_info_hash, $filename, $name,$size,$numfiles,$descr,$category,$seeders,$leechers,$completed,$hits);
        }
        // we update the hit counter for this torrent
        rewind($source);
        ftruncate($source,0);
        fwrite($source, $content);
        flock($source, LOCK_UN);
        fclose($source);

        if ($found == 0)
        {
        // not found
        header("Location: index.php");
        exit();
        }




        // we display the torrent
     	$fn = 'torrents/'.$info_hash.'.torrent';
     	header("Pragma: public");
	    header("Expires: 0");
	    header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
	    header("Content-Type: application/force-download");
	    header("Content-Type: application/octet-stream");
	    header("Content-Type: application/download");
	    header("Content-Type: application/x-bittorrent");
	    $user_agent = strtolower ($_SERVER["HTTP_USER_AGENT"]);

	    if ((is_integer (strpos($user_agent, "msie"))) && (is_integer (strpos($user_agent, "win")))) {
	      header( "Content-Disposition: filename=".$fname);
	    } else {
	      header( "Content-Disposition: attachment; filename=".$fname);
	    }

	    header("Content-Transfer-Encoding: binary");
	    header("Content-Length: ".filesize($fn));


	    @readfile($fn);
	    exit();

  }







?>